
function RoundKnob(size = 16)
{ 
    let strokeColor = MainThemeColor(Colors.black.withAlpha(0.2), Colors.mainBackground).addStyle("increasedContrast", Colors.contrastBorder);
    return Painter()
        .size(size)
        .radius(size * 2)
        .fill(Colors.knobColor)
        .stroke(1, strokeColor)
}

function PillKnob()
{
    return RoundKnob().size(9, 20).shadow().radius(4)
}

function SliderTrack(trackOn=Colors.tileTint)
{  
    return Painter()
        .size(4,4)
        .radius(-1)
        .fill(Colors.secondaryBackground)
        .insets(-2,0,0,0) 
        .state("on", Painter()
            .fill(trackOn.state("muted", Colors.secondaryBackground)) 
            .state("disabled", Painter()
                .fill(Colors.secondaryBackground)
                .addContrast()
            ).addContrast()
        )
        .state("disabled", Painter()
            .fill(Colors.secondaryBackground)
            .addContrast()
        )
        .state("active", Painter()
            .fill(Colors.secondaryBackground)
            .addContrast()
        ).addContrast();
};


function CocoaButtonBack(shadow=true,stroke=0.5)
{
    var painter = Painter()
        .fill(MainThemeColor(Colors.mainBackground.lightMode, Colors.secondaryBackground.darkMode))
        .stroke(stroke,Colors.black.withAlpha(0.3))
        .radius(Constants.buttonRadius) 
        .inset(4);
    return (shadow ? painter.shadow().addContrast() : painter.addContrast())
}