markup.push({

	"LabelView": {
		nsClass: "GXLabelView",
		gxForePainter: "LabelFore",
		gxDefaultValue: "12345",  	// just so it has a size and something visible
		gxIntrinsicHeight: 16
	},

	"DescriptionLabelView": {   
		"+": "LabelView.left.top.size11.wrap",
		axIsIgnored: false
	},
 
	// MARK: image painters

	"ImagePainter": {
		nsClass: "GXImagePainter",

		// tints for different states suited to light background
		"tintDark": {
            gxTintColor: Colors.primaryContent,
            "disabled": { gxTintColor: Colors.tertiaryContent },
            "pressed":    {
                "gxAddStyles": ["pressed"],
                gxTintColor: Colors.white,
            },
            "invertOn": {
                "on": { gxTintColor: Colors.white },
            },
		},  
	},

	"StretchHImagePainter": {
		"+": "ImagePainter",
		gxVertical: false
	},

	"StretchVImagePainter": {
		"+": "ImagePainter",
		gxVertical: true
	},

	// MARK: base control painters
	// a common base shared by painters for buttons, popup menus etc

	"ControlFore": {
		"+": "LabelFore",
		gxEdgeInsets: "2, 0, 2, 0",
		gxIconSpacing: 5,
		gxFontColor: Colors.secondaryContent,
		"on": 		{ gxFontColor: Colors.secondaryContent },
		"pressed": 	{ gxFontColor: Colors.primaryContent },
		"disabled": 	{ gxFontColor: Colors.tertiaryContent }
	},

	"ControlBack": {
		nsClass: "GXRoundRectPainter",
		gxCornerRadius: 3.5,
		gxFrameColor: Colors.secondaryContent,
		gxFillColor: Colors.tileBackground,
		gxHiliteColor: "gray:255,5",
		"on": 	{
			gxFillColor: Colors.highlightActive,
		},
		"pressed": {
			gxFrameColor: Colors.primaryContent,
			"on": {
				gxFillColor: Colors.highlightActive,
			}
		},
		"disabled": {
			gxFrameColor: Colors.tertiaryContent,
			gxFillColor: Colors.secondaryBackgroundMix,
			gxHiliteColor: "gray:255,5",
		},
		"leftSegment":   { gxCornerRadii: "3.5, 0, 0, 3.5" },
		"middleSegment": { gxCornerRadii: "0.5, 0.5, 0.5, 0.5" },
		"rightSegment":  { gxCornerRadii: "0, 3.5, 3.5, 0" }
	},

	// MARK: button view

	"ButtonView": {
		nsClass: "FGButtonView",
		gxIntrinsicHeight: 22,
		gxForePainter: "ButtonFore.size13",
		gxBackPainter: "ButtonBack",
		gxLabelTemplate: "LabelView.secondary.size11",
		gxViewFlipped: false // Fixes focus ring
	},

	// MARK: button painters

	"ButtonFore": {
		"+": "ControlFore.center"
	},

	"ButtonBack": {
		"+": "ControlBack"
	},

	// button background that only shows minimal fill when pressed
	"InvisibleButtonBack": {
		nsClass: "GXRoundRectPainter",
		gxCornerRadius: 3.5,
		"pressed": { gxFillColor: "gray:0,20" }
	},  
			
	"StyledButton" : {
		"+" : "ButtonView",
		gxBaselineOffset: 5,
		gxIntrinsicHeight: 24,
		gxBackPainter: "StyledButtonBack",
		gxLabelTemplate: "InspectorLabel.top.right.secondary.size11",
		gxForePainter: "StyledButtonFore.left"
	},
			
	"StyledButtonPopup" : {
		"+" : "StyledButton",
		nsClass: "GXPopupMenuView",
		gxExtraPainter: "PopupArrows",
		gxIntrinsicHeight: 26,
		gxLayout: [
			"V:[selfLabel(18)]"
		],
		gxForePainter: {
			"+" : "StyledButtonFore.left",
			gxEdgeInsets: "6,0,0,0",
		},
		gxDisableOnNil: false,
	},
			
	"StyledButtonFore" : {
		"+" : "InspectorBarButtonFore",
	},
			
	"StyledButtonBack" : {
		"+" : "InspectorBarButtonBack",
		"pressed":{ },
	},

	// MARK: popup menu painters

	"PopupFore": {
		"+": "ControlFore",
		gxHAlign: 0,
		gxEdgeInsets: "10, 0, 22, 0"		// extra space on right for arrows
	},

	"PopupBack": {
		"+": "ControlBack"
	},

	"PopupArrows": {
		nsClass: "GXImagePainter",
		gxEdgeInsets: "0, 0, 8, 0",	// inset from right
		gxHAlign: 1,					// aligned right
		gxVAlign: 0.5,
		gxImage: "popup.arrows",
		gxTintColor: Colors.tileTint,
		"disabled" : {
			gxTintColor: Colors.tertiaryContent
		}
	}, 
	
	// MARK: slider view

	"SliderView": {
		nsClass: "Farrago.FGNoFocusSlider", 
		gxIntrinsicHeight: 23,
		gxBaselineOffset: 7,
		gxEndGap: 7,   
        gxDrawsFocused: true,
		gxDisableOnNil: false,
		"gxAllowNumericEntry": false,
		gxTrackPainter: SliderTrack(),
		gxKnobPainter: "SliderKnob",
		gxLabelTemplate: "SliderLabel",
		gxReadoutTemplate: "SliderReadout"
	},

	// standard label for a slider
	"SliderLabel": {
		"+": "LabelView.left.secondary.size11",
	},

	// standard readout for a slider
	"SliderReadout": {
		"+": "LabelView",
		gxForePainter : {
			"+": "LabelFore.right.secondary.size10",
			"disabled" : {
				// prevent drawing when disabled by making empty rect
				gxEdgeInsets: "999,999,999,999"
			}
		},
		"seconds" : {
			gxFormatter: { nsClass: "GXScaledFormatter", "format": "%.1fs" },
		},
		gxDefaultValue: "",
		gxIntrinsicWidth: 48,
		gxIntrinsicHeight: 19,
		gxVAlign: 1,
		gxClickValue: 0
	},

	// MARK: slider painters 

	"SliderKnob":
	{
		nsClass: "GXRoundRectPainter",
		gxDefaultSize: "13, 13",
		gxCornerRadius: 6.5,
		gxFrameColor: Colors.secondaryBackground,
		gxFillColor: Colors.white,
		//gxHiliteColor: "gray:255,100",
		gxShadow: "{0.0, 0.0, 0.0 0.5}, {0.0, -1.0}, 2", 
		"focused": {
            gxStrokeWidth: 2,
			gxFillColor: Colors.tileTintPale
		},
		"disabled": {
            // prevent drawing using zero size when disabled
			gxDefaultSize: "0, 0",
		},
	},

	// MARK: list view

	"ListView": {
		nsClass: "GXListView",
		gxLayoutSubviews: true,
		gxCollapsible: false,
		gxLayoutHorizontally: false,
		gxCollapsed: false
	}, 

	// MARK: text view

	"TextView": {
		"+": "BaseTextField",
		nsClass: "FGTextView",
		gxDrawsFocusRing: true, 
		gxForePainter: "TextFieldFore", 
		gxTextStyle: {
			nsClass: "GXStyledString",
			gxBackColor: Colors.invisible,
			gxFontSize: 13,   
		},
		gxLinkDetectionEnabled: true,
	},

	// MARK: textfield view

	"BaseTextField": {	// note: code depends on the name 'BaseTextField' when looking up gxSelectionColor
		nsClass: "GXTextField",
		gxBaselineOffset: 2,
		//gxDisabledAlphaColor: "gray:255,28", // placed over everything when disabled
		gxInsertionPointColor: Colors.primaryContent,
		gxSelectionColor: "rgba:167,201,255,100",	// overrides system hilite color for user selection
		gxLabelTemplate: "LabelView.right.primary.size13",
		gxBackPainter: "TextFieldBack",
		gxPlaceholderStyle: "PlaceholderStyle",
        "gxTextPainter": "TextFieldFore",
	},

	"TextField": {
		"+": "BaseTextField"
	},

	"TextFieldFore": {
		"+": "LabelFore.left.top.size13", 
		gxFontColor: Colors.primaryContent,
		gxBackColor: "name:invisible", 
	},

	"TextFieldBack": {
		nsClass: "GXRoundRectPainter",
		gxCornerRadius: 0, 
		gxFillColor: MainThemeColor(Colors.white, Colors.secondaryBackground), 
	},

	"PlaceholderStyle": {
		nsClass: "GXStyledString",
		gxFontSize: 13,
		gxFontColor: Colors.secondaryContent
	}, 

	// MARK: formatters

    "PercentageFormatter": ScaledFormatter("% .0f%%", 100), 
});
