function ToolBar()
{
	return VStack([ 
		HStack([   
			 
			ZStack([
				PlayerVolumeView("Master")
					.width(160)
					.leftPad(0)
					.viewName("masterVolumeView")
					// Draw label below the sliders
					.backPainter(LabelPainter("Master Volume")
						.align(0.5,1) 
						.color(Colors.secondaryContent))
					, 
			])
			.makeView()
			.addLayout("H:[self(<=1@200)]"), 

			Padding(15),  
			
			// Now playing / LCD
			View("FGLCDView").childViews([  
  
				View().childViews([    
					Label("Farrago") 
						.topPad(2)  
						.centerH()
						.fontColor(MainThemeColor(Colors.secondaryContent, Colors.white)).fontSize(13)
						.animateVisibility(0.5, 0)
						.showKey("showTitle"), 

					NowPlayingView() 
							.intrinsicSize(-1, 40)
							.leftPad(10)
							.rightPad(40)
							.viewName("nowPlaying")
							.fillHeight(),     
					LevelMeters()
						.viewName("meters")
						.vPad(5) 
						.rightPad(10)
						.keyPath("meterNode"),  
				])   
				.viewName("lcdView")  
				.keyPath("")
				.fillHeight()  
				.backPainter(Painter().fill(Colors.secondaryBackground).radius(14).stroke(1, Colors.contrast))
				
			])
			.makeView("FGLCDView")      
			.viewName("lcd")
			,
			
			
			   
			// Transport  
			Padding(15), 
			HStack([ 
					
				ToolbarButtonDark("control-previous", "Previous", "", "prevBtn")
						.setAXHelp("Plays previous track in playlist")
						.width(55)
						.collapseKey("fullTransportHidden", true),
				ToolbarButtonDark("control-next", "Next", "", "nextBtn")
					.setAXHelp("Plays next track in playlist")
					.width(56)
					.collapseKey("fullTransportHidden", true),

				ToolbarButtonDark("control-playpause", "Pause All", "pauseBtnText", "pauseBtn")    
					.setAXHelp("Pauses all playing tiles")
					.width(68),
				ToolbarButtonDark("control-stop", "Stop All", "", "stopBtn") 
					.setAXHelp("Stops all playing tiles")
					.width(50),
				ToolbarButtonDark("control-fade-out", "Fade All", "", "fadeBtn")  
					.setAXHelp("Fades out all playing tiles")
					.width(60),
			])
			.makeView()  
			.fillHeight()
			.addLayout("H:[self(<=1@200)]"), 
		]), 
	]) 
	.makeView("GXSettingsView")      
	.keyPath("")
	.addLayout(`V:[self(>=${Constants.headerHeight})]`)     
}