 

markup.push({
	    

	"TileView": {
		nsClass: "Farrago.FGTileView",
		gxDraggable: true, 
		selectable: true,
		multipleSelection: true,
		gxWantsLayer: true,
		axIsIgnored: false,
		gxMaintainSelectionOnContextMenu: true,
		gxAutoLoadConstraints: false,
		gxSelectOnContextMenu: true,
		axRoleDescription: "Audio Tile",
		axTitleKeyPath : "title",
		axDescriptionKeyPath : "axDescription",
		axHelpKeyPath  : "axHelp",
		gxDragController: { nsClass: "Farrago.FGDragTileController" },
		gxMenuItemsKeyPath: "contextualMenuItems",    
		// gxBackPainter: Painter().radius(8).fill(Colors.warning),  
		gxChildViews: TileChildViews(), 
	},
	
	"GhostTileView": {
		nsClass: "Farrago.FGGhostView",
		selectable: true,
		multipleSelection: true,
		axIsIgnored: false,
		axRoleDescription: "Tile",
		axTitleKeyPath: "title",   
		gxChildViews: {  
			"tileHostingView" : {
				nsClass: "GXLayerHostingView",
				gxValueKeyPath:"", 
				gxRootLayer: {
					nsClass: "GXDrawLayer",
					gxNeedsDisplayOnResize: false, 
					gxSublayers: {
						"backLayer": {
							nsClass: "GXDrawLayer",  
							"gxSetLayerContentImage": true,         // make an image for layer content
							gxNeedsDisplayOnResize: false,          // don't redraw when stretched
							gxContentsCenter: "0.5, 0.5, 0, 0",     // resize by stretching center pixel h and v
							"gxContentsGravity": "resize",  // resize content
							gxLayerZPosition: 0,
							gxBackPainter: 	{
								nsClass: "GXRoundRectPainter",
								gxEdgeInsets: "7, 4, 7, 5",
								gxCornerRadii: "8, 8, 8, 8",
								gxStrokeWidth: 0.5,
								gxFrameColor: Colors.secondaryContent,
								gxFillColor: Colors.mainBackground,
								gxDefaultSize: "40,40",        // size to make content image
							}, 
						},
						"hotKey": {
							nsClass: "GXStringLayer", 
							gxLayerZPosition: 5,
							"gxContentsGravity": "center",
							gxFrameRect: "0,0,62,36", 
							gxForePainter: {
								"+": "LabelFore.bottom.centerx.size13",
								gxFontColor: Colors.secondaryContent,
								gxBackColor: Colors.mainBackground,
							},
							gxNeedsDisplayOnResize: false,
						},
					}
				}
			}
		}
	}, 
 
	"TilePillForePainter" : {
		"+": "LabelFore.center.size22",  
		gxEdgeInsets: "0,2,0,3",
		gxFontColor: Colors.tilePillFont,
	},

	"TileTitleFore" : {
		"+": "LabelFore.top.left",     
		gxFontWeight: 0.2,
		gxFontSize: 18, 
		gxLineBreakMode: 0,
		gxStyledString: {
			nsClass: "FGStyledString",
		},
	}, 
	
	"NotesViewContainer": // this name is referenced in code
	{ 
			nsClass: "GXSettingsView",
			gxLayerZPosition: 0,
			gxBackPainter: Painter().fill(Colors.mainBackground).insets(20,0,0,0).radius(6),
			gxLayout: [
				"H:|[noteLayers]|",
				"V:|[noteLayers]|", 
			],
			gxAutoLoadConstraints: true,
			gxChildViews: {
				"notesScrollView" : ScrollView(TemplateView("TextView").setValues({    
					nsClass: "FGTileViewNotesField",
					gxIntrinsicSize: "-1,-1", 
					gxAcceptableDragTypes: ["NSPasteboardTypeString"],
					gxResizeHeightToFitContent: true,
					gxEditable: true,
					gxValueKeyPath : "notes",
					gxDisableOnKey: "tileSet.security.setLocked",
					drawsSelected: true,  
					gxPlaceholderString: "Click to add note...",  
					gxBackPainter: Painter().fill(Colors.mainBackground),
					gxPlaceholderTextPainter: {
						"+" : "TextFieldFore", 
						gxFontColor: "gray:150,100", 
					},   
				}) 
					.enableKey("notesEnabled") 
					.viewName("notesView")
					.fillWidth()  
				)  
				.keyPath("")
				.className("FGTileViewNotesScrollView")
				.backColor(Colors.mainBackground)
				.vScroller(VScrollbarView(Colors.secondaryBackground, MainThemeColor(Colors.white, Colors.secondaryBackground)))
				// .setValue(false, "gxAutohidesScrollers") 
				.addLayout("H:|-26-[self]-6-|") // Insets account for the background being square, while the frame is rounded
				.addLayout("V:|-8-[self(>=30)]-8-|") 
				.hScroller(null),
  
				"noteLayers" : {
					nsClass: "GXLayerHostingView", 
					gxValueKeyPath: "",
					gxLayout: [
						"H:|-0-[notesDashLayer(20)]-0-[notesBackLayer]-0-|",
						"V:|[notesBackLayer]|",
						`V:|-${(Constants.tileHeightList / 2) - 3}-[notesDashLayer(3)]`,
					],
					gxRootLayer: {
						nsClass: "GXDrawLayer", 
						gxNeedsDisplayOnResize: false, 
						gxValueKeyPath: "",
						gxSublayers: {
							"notesBackLayer": // this name is referenced in code
							{
								nsClass: "FGFocusAwareLayer", 
								gxLayerZPosition: 11,
								gxNeedsDisplayOnResize: true,
								drawsSelected: true,
								gxValueKeyPath: "",
								"gxContentsGravity": "bottomLeft",  // actually top left to any sane person
								gxBackPainter: {
									nsClass: "GXRoundRectPainter",
									gxCornerRadius: 6, 
									gxFrameColor: Colors.divider,
									gxEdgeInsets: "0,4,0,4",
									"selected" : {
										gxStrokeWidth: 3,
										gxEdgeInsets: "0,2,0,2",
										gxFrameColor: Colors.tertiary,
									},
									"focused" : {
										gxStrokeWidth: 3,
										gxEdgeInsets: "0,2,0,2",
										gxFrameColor: Colors.tileTint,
									},
								},
							},
							"notesDashLayer": // this name is referenced in code
							{
								nsClass: "FGFocusAwareLayer", 
								gxNeedsDisplayOnResize: false,          // don't redraw when stretched
								gxValueKeyPath : "",
								gxLayerZPosition: 11,
								drawsSelected: true,
								gxBackPainter: {
									nsClass: "GXPainter",
									gxFillColor: Colors.divider, 
									gxEdgeInsets: "0,1,0,1",
									"selected" : {
										gxStrokeWidth: 3,
										gxEdgeInsets: "0,0,0,0",
										gxFillColor: Colors.tertiary,
									},
									"focused" : {
										gxStrokeWidth: 3,
										gxEdgeInsets: "0,0,0,0",
										gxFillColor: Colors.tileTint,
									}
								},
							}, 
						}
					}
				}, 
			}
		},  
});

function LoadingSpinner(size = 30)
{
	return View("GXSpinnerView").setValues({ 
		gxValueKeyPath: "",
		gxAnimateOnKey: "hasSpinner",
		gxStepSize: 30, // Rotate 30 degree increments
		gxSpinAngleScale: 640, // Match speed of system spinner 
		gxShowOnKey: "hasSpinner",
		gxAutoLoadConstraints: true,
		gxSpinLayer: {
			nsClass: "GXDrawLayer",
			gxForePainter: {
				"+" : "ImagePainter.spinner",
				gxTintColor: Colors.secondaryContent,
			},
			gxFrameRect: `0,0,${size},${size}`,
			gxAnchorPoint: "0.5, 0.5",	// spin around center
			gxNeedsDisplayOnResize: false,
			gxOpacity: 1,	// start invisible
		},
	})
	.size(size)
	.layerZ(102)
	.viewName("loadingSpinner");
} 

function TitleLayer({size, weight, fontColor, height})
{
	return Layer("GXStringLayer").setValues({ 
		gxValueKeyPath: "title",
		gxLayerZPosition: 2,   
		gxNeedsDisplayOnResize: true,
		gxRendersTransform: true,
		gxForePainter: {
			"+" : "TileTitleFore", 
			gxFontColor: fontColor,   
			gxFontSize: size,
			gxFontWeight: weight,
		},   
		// gxBackPainter: Painter().stroke(1, Colors.warning)
	});
} 

function TileChildViews(hotKeys = true)
{
	return {  
		
		"loadingSpinner" : LoadingSpinner(), 
		
		"playingSpinner" : ZStack([  
			
			LayerView([
				Layer("GXCaarLayer")  
					.keyPath("")
					.viewName("playingSpinnerLayers")
					.setValues({
						gxRespectsReduceMotion: false,
						gxStartTime: 1,
						"gxCaarPainter" : Painter("GXCaarPainter").size(12).setValues({ 
							gxTintColor : Colors.tileTint, 
							gxLoopStart : -1,
							gxAssetDuration: 1,  
							"playing" : {
								gxAsset : "list.playing",
								gxLoopStart : 1,
								gxAssetDuration: 2,  
							},
							"mark" : {
								gxAsset : "list.mark", 
								gxLoopStart : -1,
								gxAssetDuration: 1,  
							}
						}) 
					}).fillFrame() 
			]) 
				.keyPath("")    
				.fillFrame(), 

			View() 
				.showKey("showListPlayed") 
				.center()
				.size(14)
				.backPainter(Painter().radius(-1).stroke(1, Colors.tertiaryContent)),

		])
		.makeView()
		.showKey("isListMode")
		.keyPath("")
		.size(20),  
		  
		"tileLayerHost" : TileHostingView(hotKeys),
		"bottomView" : View(), // This view is used for ignoring mouse events 
	};
}  

function HotKeyLayers(keypath)
{
	let backPainter = Painter()
		.insets(2,2,2,2)
		.stroke(2, Colors.tileBackground)
		.fill(Colors.tilePillBack)
		.radius(14)
		.addStyleWithPainter("increasedContrast", (painter) => {
			return painter.stroke(1, Colors.contrastBorder);
		});

	return Layer("GXStringLayer")  
		.size(Constants.hotKeyWidth,Constants.hotKeyHeight)
		.layerZ(21) 
		.setValues({
			gxNeedsDisplayOnResize: false,
		})
		.backPainter(backPainter)
		.forePainter(TemplatePainter("TilePillForePainter").weight(0.2).align(0.5,0.5).inset(2))
		.keyPath(keypath) 
}

function HotKeyLayerDisabled()
{
	return Layer().layerZ(25).subLayers([
		DisabledStripeLayer() 	
			.keyPath("")
			.mask(Layer()
				.setValue(true, "gxSetLayerContentImage")
				.backPainter(Painter()
					.size(Constants.hotKeyWidth,Constants.hotKeyHeight)
					.radius(-1)
					.inset(2)
					.fill(Colors.tileTintLight))
				).size(Constants.hotKeyWidth,Constants.hotKeyHeight),
	])
}

function TileHostingView(hotkeys = false, selection = true, hasLicence = false, backgroundColor = Colors.tileBackground)
{
	return View().setValues({
		nsClass: "FGTileLayerHost",
        gxToolTipKeyPath: "title",
		gxValueKeyPath: "",  
		gxRootLayer: {
			nsClass: "FGTileLayers", 
			gxValueKeyPath: "",
			gxNeedsDisplayOnResize: false, 
			gxSublayers: TileLayers(backgroundColor, selection, hotkeys, hasLicence)
		}
	}).viewName("tileLayerHost")
}

function TileLayers(backgroundColor, selection, hotkeys, hasLicence)
{
	return {
		  

		backLayer: MakeTileLayers({ foreground: false, backgroundColor: backgroundColor, hasLicence: hasLicence }),
		foreLayer: MakeTileLayers({ foreground: true,  backgroundColor: Colors.tileTint, hasLicence: hasLicence }),

		"hotKeyLayerLeft": HotKeyLayers("hotKey").loaded(hotkeys),
		"hotKeyLayerCenter": HotKeyLayers("hotKey").loaded(hotkeys),
		"midiNoteLayer": HotKeyLayers("midiResponder.midiNoteValue").loaded(hotkeys),
		"midiNoteDisabled": HotKeyLayerDisabled().loaded(hotkeys),
		
		"selectionLayer": selection ? SelectionLayer(Colors.tertiary.addStyle("focused", Colors.tileTint)) : { nsClass: "GXDrawLayer" }, 
 
		"queueLayer": SelectionLayer(Colors.tertiary)
			.animateVisibility(0.5,0)
			.showKey("showQueued"),

		"searchOverlay": Layer()
			.keyPath("") 
			.backPainter(
				Painter()
					.radius(8)
					.inset(4)
					.size(20,20)
					.fill(Colors.mainBackground.withAlpha(0.7))
			) 
			.showKey("showSearchOverlay") 
			.layerZ(50)
			.setValues({
				gxContentsCenter: "0.5, 0.5, 0, 0",
				gxContentsGravity: "resize",
				gxNeedsDisplayOnResize: false,
				gxSetLayerContentImage: true,
			})
		,
		"disabledOverlay": Layer()
			.showKey("playbackDisabled")
			.backPainter(Painter().size(20,20).radius(6).inset(4.5).fill(Colors.mainBackground))
			.opacity(0.5)
			.layerZ(49)
			.setValues({
				gxContentsCenter: "0.5, 0.5, 0, 0",
				gxContentsGravity: "resize",
				gxNeedsDisplayOnResize: false,
				gxSetLayerContentImage: true,
			}),
		"disabledStripe": DisabledStripeLayer()
			.layerZ(50)
			.mask(Layer().fillFrame().backPainter(Painter().radius(8).inset(4).fill(Colors.black)))
			.showKey("playbackDisabled"),
 
	};
}

function DisabledStripeLayer()
{
	return Layer("FGPatternImageLayer")
		.setValues({
			gxMaskToBounds : true,
			gxNeedsDisplayOnResize : false
		}) 
		.forePainter(ImagePainter("disabledPattern").fill(Colors.tileTint))
		.opacity(0.25) 
}

function ImageLayer(imageName, tintColor = Colors.tileTint)
{
	return Layer()
		.keyPath("") 
		.setValues({
			gxNeedsDisplayOnResize: true,
			// gxSetLayerContentImage: true,
		})
		.forePainter(ImagePainter(imageName).tintColor(tintColor)) 
}

function LoopIcon(foreground)
{
	return Layer().setValues({ 
		gxValueKeyPath: "", 
		gxLayerZPosition: 3,
		// gxNeedsDisplayOnResize: false,      
		gxBackPainter: {
			"+" : "ImagePainter",
			gxImage: "tile-icon",
			gxHAlign:1, 
			gxVAlign:0.5,  
			gxTintColor: foreground ? Colors.tileBackground : Colors.tileTint,
		},
	});
}

function Readout(left, fontColor, size)
{
	return { 
		nsClass: "GXStringLayer",  
		gxFrameRect: `0,0,${Constants.readoutWidth},${Constants.readoutHeight}`,
		gxValueKeyPath: left ? "currentPlayingOrPreviewTimeString" : "remainingPlayingOrPreviewTimeString",
		gxAnimateOnKey: "playingOrPreviewing",
		gxLayerZPosition: 2,
		gxNeedsDisplayOnResize: false,  
		gxRendersTransform: true, 
		gxDefaultValue: "0:00.00", 
		gxForePainter: {
			"+": "LabelFore.bottom",   
			gxStyledString: {
				nsClass: "FGFixedWidthString", 
			},
			gxDefaultSize: `${Constants.readoutWidth},${Constants.readoutHeight}`,
			gxFontColor: fontColor,
			gxFontSize: size,
			gxFontWeight: -0.4,
			gxVAlign: 0.75,
			gxHAlign: left ? 0.0 : 1.0,
			gxMonoSpacedDigits: true,
		},  
		// gxBackPainter: Painter().stroke(1, Colors.warning)
	};
}

function BaseLicenceIcon(foreground)
{
	return Layer()
		.keyPath("licenseImage")
		.setValues({
			nsClass: "GXImageLayer",   
			gxHideOnNilValue: true,
			gxNeedsDisplayOnResize: false, 
		})
		.forePainter(ImagePainter().offset(1,1).tintColor(foreground ? Colors.tileTintLight : Colors.tileTint));
}
// MARK: Function for building the mostly duplicated foreground and background layers

function MakeTileLayers({foreground, backgroundColor, hasLicence})
{ 
	let fontColor = foreground ? Colors.tileBackground : Colors.tileTint 
	return Layer().setValues({ 
		gxValueKeyPath: "",                         // receive update for tint color changes  
		gxBackPainter: 	
		{ 
			nsClass: "GXRoundRectPainter",
			gxEdgeInsets: "4, 4, 4, 4",
			gxCornerRadius: 6,  
			gxFillColor: backgroundColor,
			gxDefaultSize: "40,40",        // the size of content image
			gxStrokeWidth: 0.5,
			gxFrameColor: MainThemeColor(Colors.black.withAlpha(0.4), Colors.white.withAlpha(0.15)).addStyle("increasedContrast", Colors.contrastBorder),
			gxShadow: foreground ? "" : Shadow(Colors.shadowColor,0,0,5), // Effecient, because we only create this once and reuse the image
			"increasedContrast": {
				gxFrameColor: Colors.contrastBorder,
				gxStrokeWidth: 1,
			}
		}, 
		"gxSetLayerContentImage": true,         // make an image for layer content
		gxNeedsDisplayOnResize: false,          // don't redraw when stretched
		gxContentsCenter: "0.5, 0.5, 0, 0",     // resize by stretching center pixel h and v
		"gxContentsGravity": "resize",  // resize content 
		gxLayerZPosition: foreground ? 20 : 10,
		gxSublayers: {   
			
			[`title${foreground ? "Fore" : "Back"}Biggest`]: TitleLayer({size: 15, weight: 0.2, fontColor: fontColor, height:60}),  
			[`title${foreground ? "Fore" : "Back"}Big`]: 	 TitleLayer({size: 13, weight: 0.1, fontColor: fontColor, height:45}), 
			[`title${foreground ? "Fore" : "Back"}Small`]: 	 TitleLayer({size: 11, weight: 0,   fontColor: fontColor, height:45}), 

			[`lock${foreground ? "Fore" : "Back"}`]: ImageLayer("lock-fill", fontColor),
		
			[`leftReadout${foreground ? "Fore" : "Back"}Small`]: Readout(true, fontColor, 11),
			[`rightReadout${foreground ? "Fore" : "Back"}Small`]: Readout(false, fontColor, 11),

			[`leftReadout${foreground ? "Fore" : "Back"}Big`]: Readout(true, fontColor, 13),
			[`rightReadout${foreground ? "Fore" : "Back"}Big`]: Readout(false, fontColor, 13),

			[`loopIcon${foreground ? "Fore" : "Back"}`]: LoopIcon(foreground),
		  
			// Licence Icon	
			[`licenseIcon${foreground ? "Fore" : "Back"}`]: BaseLicenceIcon(foreground)  
				.backPainter(Painter().fill((foreground ? Colors.tileTint : Colors.tileTintPale)).insets(1,0,0,1).radii(0,5.5,5.5,0))
				.layerZ(41)
				.loaded(hasLicence),
			 
			[`licenseIconFrame${foreground ? "Fore" : "Back"}`]: BaseLicenceIcon(foreground)
				.backPainter(Painter()
				.fill((foreground ? Colors.tileTint : backgroundColor)) 
				.radii(0,6,6,0))
				.forePainter(null)
				.layerZ(40)
				.loaded(hasLicence),

			[`tileIcon${foreground ? "Fore" : "Back"}`] : Layer("GXStringLayer")
				.keyPath("tileIconString")    
				.layerZ(1) 
				.setValues({
					gxNeedsDisplayOnResize: false,
					gxContentsGravity: "", 
				})  
				.forePainter(LabelPainter()  
					.fontSize(60) 
					.lineBreakMode(2)  
					.shadow(foreground ? Colors.mainBackground : Colors.invisible, 0, 0, 4) 
					.setValues({
						gxStyledString: {
							nsClass: "FGStyledString",
						},
					})
					.color(Colors.tileTint)),    
			[`wave${foreground ? "Fore" : "Back"}`]: {
				nsClass: "GXWaveLayer",   
				gxValueKeyPath: "shapedWaveData",
				"trimWaveform": true,   // fill the tile with wave between start and end points  
				gxNeedsDisplayOnResize: false,
				gxBackPainter: {
					nsClass: "GXWavePainter", 
					gxFillColor: foreground ? Colors.tileWaveForeColor : Colors.tileTintPale,
				},
			},
			[`waveImage${foreground ? "Fore" : "Back"}`]: {
				nsClass: "FGWaveImageLayer",  
				gxValueKeyPath: "waveFormImage",  
				gxHideOnNilValue: true, 
				gxNeedsDisplayOnResize: true,
				gxContentsCenter: "0, 0.5, 0, 0",     // resize by stretching center pixel h and v
				gxContentsGravity: "resize",  // resize content
				gxBackPainter: Painter().fill(foreground ? Colors.tileWaveForeColor : Colors.tileTintPale), 
			},
		}
	});
};

function PlayerPreviewLayer(size=28)
{
	return Layer().subLayers([
		Layer()
			.keyPath("")
			.forePainter(Painter().fill(Colors.tileTint).radius(-1))
			.size(size),
		Layer("CAShapeLayer")
			.keyPath("")
			.viewName("playFill"),
		Layer()
			.showKey("preview")
			.forePainter(ImagePainter("control-playstop-small").tintColor(Colors.tileBackground))
			.size(size),
		Layer()
			.hideKey("preview")
			.forePainter(ImagePainter("control-playstop-small.on").tintColor(Colors.tileBackground).offset(1,0))
			.size(size),
		Layer()
			.keyPath("")
			.showKey("hasSpinner")
			.forePainter(Painter().fill(Colors.tileTint).radius(-1).inset(4))
			.size(size),
	])
	.size(size)
	.viewName("previewLayer")
	.className("Farrago.FGPreviewLayer")
	.showKey("showPreviewBtn")
	.layerZ(22)
	.setValues({
		"playFillColor" : Colors.tileBackground,
	})
}

function SelectionLayer(tint)
{  
	return Layer("FGFocusAwareLayer")
		.keyPath("")
		.layerZ(52)
		.showKey("selected")
		.backPainter(Painter().stroke(3, tint).radius(8).inset(2).size(40,40)) 
		.setValues({ 
			"gxNeedsDisplayOnResize": true,          // don't redraw when stretched
			"gxContentsCenter": "0.5, 0.5, 0, 0",     // resize by stretching center pixel h and v
			"gxContentsGravity": "resize",  // resize content
		});
}